#!/usr/bin/tclsh

#
# This is a simple example of a command line module written as a shell script.
#
# In this case, two other command line modules are used in sequence to implement
# a multi-step workflow.
#

if {$argv == "--xml"} {

  puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
  puts "<executable>"
    puts "<category> MATLAB Modules</category>"
    puts "<title> Example MATLAB Module </title>"
    puts "<description> An example MATLAB CLI plugin. </description>"
    puts "<version> 1.0</version>"
    puts "<documentation-url></documentation-url>"
    puts "<license></license>"
    puts "<contributor> Steve Pieper, Ph.D. & John Melonakos </contributor>"
    puts "<acknowledgements> This work is part of the National Alliance for Medical Image Computing (NAMIC), funded by the National Institutes of Health through the NIH Roadmap for Medical Research, Grant U54 EB005149. </acknowledgements>"
   puts "<parameters>"
      puts "<label>Input/Output</label>"
      puts "<description>Input/output parameters</description>"
      puts "<image>"
        puts "<name>InputVolume0</name>"
        puts "<label>Input Volume 0</label>"
        puts "<channel>input</channel>"
        puts "<index>0</index>"
        puts "<default>None</default>"
        puts "<description>Input volume 0</description>"
      puts "</image>"
      puts "<image>"
        puts "<name>InputVolume1</name>"
        puts "<label>Input Volume 1</label>"
        puts "<channel>input</channel>"
        puts "<index>1</index>"
        puts "<default>None</default>"
        puts "<description>Input volume 1</description>"
      puts "</image>"
      puts "<image>"
        puts "<name>OutputVolume0</name>"
        puts "<label>Output Volume 0</label>"
        puts "<channel>output</channel>"
        puts "<index>2</index>"
        puts "<default>None</default>"
        puts "<description>Output filtered 0</description>"
      puts "</image>"
      puts "<image>"
        puts "<name>OutputVolume1</name>"
        puts "<label>Output Volume 1</label>"
        puts "<channel>output</channel>"
        puts "<index>3</index>"
        puts "<default>None</default>"
        puts "<description>Output filtered 1</description>"
      puts "</image>"
  puts "</parameters>"
  puts "</executable>"
  exit 0
}
foreach {a b c d} $argv {}

set fp [open "|/usr/local/bin/matlab -nodesktop -nosplash" "w"]
puts $fp "addpath('./MATLAB/');"
puts $fp "MATLABSlicerExampleModule('$a','$b','$c','$d');"
close $fp

# Other options that may work:
# exec /bin/sh /usr/local/bin/matlab -nodesktop -nosplash -r \"addpath('./MATLAB/')\;MATLABSlicerModule('$a','$b','$c','$d')\;\"
# exec matlab -nodesktop -nosplash -r fprintf\('%s,%s,%s,%s\n',$a,$b,$c,$d\)\;exit\;
